import { Writable } from 'node:stream';
export const awslambdaSimulator = () => {
    let responseStream;
    let responseResult;
    responseStream = new Writable({
        write(chunk, encoding, callback) {
            //console.log(chunk.toString());
            if (!responseResult) {
                responseResult = chunk;
            }
            else {
                responseResult = Buffer.concat([responseResult, chunk]);
            }
            callback();
        },
    });
    return {
        awslambda: {
            streamifyResponse: (handler) => async (event, context) => {
                await handler(event, responseStream, context);
                return responseStream;
            },
            HttpResponseStream: {
                from(responseStream, metadata) {
                    //TODOD: implement writing metadata to responseStream
                    return responseStream;
                },
            },
        },
        streamifyHandler: (handler) => async (event, context) => {
            await handler(event, responseStream, context);
            return responseResult.toString('utf-8');
        },
    };
};
